//HT46C_SER01_RC.c
//18.06.2012

#include "HT46F47E.h"

#pragma vector isr_4 @ 0x4
#pragma vector isr_8 @ 0x8
#pragma vector isr_c @ 0xc

//ISR for safequard
void isr_4(){} // external ISR
void isr_8(){} // timer/event 0
void isr_c(){} // timer/event 1


unsigned char n,A_Reg,c,E_Reg,i;

//initialize registers for safeguard
void safeguard_init(){
	_intc = 0;
	_tmrc = 0;
	_tmr = 0;
	_pac = 0xff; //input mode
	_pbc = 0xff;
}


void shortdelay()
{
for(n=0;n<5;n++);
}

void WrCOM()
{
	_pb1=1;
	shortdelay();	
    for(c=0;c<8;c++) 
{	
	if((E_Reg & 1)==0)
	{
	_pb1=1;
	}
	else
	{
	_pb1=0;
	}
	shortdelay();
	E_Reg=E_Reg>>1;   // Inhalt von E_Reg 1 Bit nach rechts schieben
}	
   
    _pb1=0;	
   shortdelay();
}

RdCOM()
{
	while(_pb2==0);
	for(n=0;n<9;n++); //1,5 Bit Wartezeit
	E_Reg=0;
	for(c=0;c<8;c++) 
{
	E_Reg=E_Reg>>1;
	if(_pb2==1)
	{
	E_Reg=E_Reg|128;
	}
	shortdelay();
}
	shortdelay();
	E_Reg=255-E_Reg;
}	    	

void main(){
	
	safeguard_init();
	_pac = 0;
    _pbc1=0;
    _pbc3=0;
    _pbc2=1;
    _pa=0;
    _pb1=1;
    _pdc0=0;  // PD0 Ausgang
    _pd0=1;   // PWM ein
    _pbc0=0;
    _eadi = 0; //Kein Interupt
	_acsr = 1; //AD-Clock = 1/8
    i=0;
    _pb3=0;
    E_Reg=85;
    WrCOM();
    
while(1)
{    
    A_Reg=0;
    RdCOM();
    A_Reg=E_Reg;
    switch(A_Reg)
{    
    case 1:
    _pac = 0;  // Port A Ausgang
    RdCOM();	
    _pa=E_Reg;
    break;
    case 2:
    _pac=0xff;  // Port A Eingang
    //_pa=0xff;
    E_Reg=_pa;
    WrCOM();
    _pac=0;	
    break;
    case 3:     // PWM
    RdCOM();
    _pwm=E_Reg;
    break;
    case 4:     // ADC0 
    _adcr = 8;      //nur B0 als ADC0, AdC0 gewaehlt
	_start=0;
	_start=1;       //AD-Start
	_start=0;
    while (_eocb==1);
 	E_Reg =_adrh;     //Aufloesung 8 Bit 
    WrCOM();
    break;			
    case 5:    // pb3 setzen
    _pb3=1;
    break;
    case 6:   // pb3 zuruecksetzen
    _pb3=0;
    break;
    case 7:   // Test
    E_Reg=85;
    WrCOM();
    E_Reg=170;
    WrCOM();
    break;
    
    default:
    break;
    }		  
    
     
}
}